SystemOrganization addCategory: #SlotTests!

Trait named: #TOne
	uses: {}
	category: 'SlotTests'!

!TOne classSide methodsFor: 'testing' stamp: 'MartinDias 7/1/2013 12:39'!
classOne
	^ 1! !

!TOne methodsFor: 'testing' stamp: 'MartinDias 8/1/2012 00:06'!
one
	^ 1! !

Trait named: #TTwo
	uses: {}
	category: 'SlotTests'!

!TTwo methodsFor: 'as yet unclassified' stamp: 'MartinDias 8/1/2012 00:11'!
two
	^ 2! !

SharedPool subclass: #TestSharedPool
	instanceVariableNames: ''
	classVariableNames: 'One'
	poolDictionaries: ''
	category: 'SlotTests'!

!TestSharedPool class methodsFor: 'class initialization' stamp: 'MartinDias 8/7/2012 02:06'!
initialize
	One := 1! !

TestCase subclass: #SlotClassBuilderTest
	instanceVariableNames: 'aClass instance anotherClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotTests'!

SlotClassBuilderTest subclass: #SlotClassBuilderAnnouncementsTest
	instanceVariableNames: 'announcement announcementsCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotTests'!

!SlotClassBuilderAnnouncementsTest methodsFor: 'helpers' stamp: 'MartinDias 6/3/2013 17:01'!
assertOnlyOneAnnouncementOf: anAnnouncement within: aBlock
	SystemAnnouncer uniqueInstance weak on: anAnnouncement send: #countAnnouncements: to: self.
	aBlock value.
	self assert: announcementsCount <= 1! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'helpers' stamp: 'MartinDias 6/3/2013 17:00'!
countAnnouncements: anAnnouncement 
	announcementsCount := announcementsCount + 1! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'helpers' stamp: 'MartinDias 6/3/2013 17:00'!
saveAnnouncement: anAnnouncement
	announcement := anAnnouncement! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'helpers' stamp: 'MartinDias 6/3/2013 17:00'!
saveAnnouncementOnce: anAnnouncement
	announcement ifNotNil: [ ^self ].
	announcement := anAnnouncement! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'running' stamp: 'MartinDias 6/3/2013 17:19'!
setUp
	super setUp.
	announcementsCount := 0.! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'tests' stamp: 'MartinDias 7/8/2013 16:05'!
testClassAddedAnnounced
	SystemAnnouncer uniqueInstance weak on: ClassAdded send: #saveAnnouncement: to: self.
	
	aClass := self makeWithLayout: PointerLayout.
	
	self assert: announcement classAdded equals: aClass.! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'tests' stamp: 'MartinDias 7/8/2013 16:05'!
testClassAddedAnnouncedOnlyOnce
	self assertOnlyOneAnnouncementOf: ClassAdded within: [
		"We create a new class without slots"
		self makeWithLayout: PointerLayout.
	]! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'tests' stamp: 'MartinDias 7/8/2013 16:05'!
testClassFormatChangedAnnounced
	| classAdded classModified |
	SystemAnnouncer uniqueInstance weak on: ClassModifiedClassDefinition send: #saveAnnouncementOnce: to: self.
	
	"We create a new class without slots"
	classAdded := self makeWithLayout: PointerLayout.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self makeWithLayout: WeakLayout.
	
	self assert: announcement newClassDefinition equals: classModified.
	self assert: announcement oldClassDefinition format equals: classAdded format.
	self assert: announcement newClassDefinition format equals: classModified format.! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'tests' stamp: 'MartinDias 7/8/2013 16:06'!
testClassModifiedAnnounced
	| classAdded classModified |
	SystemAnnouncer uniqueInstance weak on: ClassModifiedClassDefinition send: #saveAnnouncementOnce: to: self.
	
	"We create a new class without slots"
	classAdded := self makeWithLayout: PointerLayout.
	
	"now we extend it with slots.  The class definition should've changed"
	classModified := self makeWithLayout: PointerLayout andSlots: { #aSlot }.
	
	self assert: announcement newClassDefinition equals: classModified.
	self assert: announcement oldClassDefinition allInstVarNames equals: classAdded allInstVarNames.! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'tests' stamp: 'MartinDias 7/8/2013 16:06'!
testClassModifiedAnnouncedOnlyOnce
	
	self assertOnlyOneAnnouncementOf: ClassModifiedClassDefinition within: [
		
		"We create a new class without slots"
		self makeWithLayout: PointerLayout.
		
		"now we extend it with slots.  The class definition should've changed"
		self makeWithLayout: PointerLayout andSlots: { #aSlot }.
	]! !

!SlotClassBuilderAnnouncementsTest methodsFor: 'tests' stamp: 'MartinDias 7/8/2013 16:05'!
testClassRecategorizedAnnounced

	SystemAnnouncer uniqueInstance weak 
		on: ClassRecategorized 
		send: #saveAnnouncementOnce: 
		to: self.
	
	aClass := self make: [:builder|
		builder category: self aCategory ].	
	anotherClass := self make: [:builder|
		builder category: self anotherCategory ].
	
	self assert: announcement oldCategory equals: self aCategory.
	self assert: announcement newCategory equals: self anotherCategory.
	self assert: announcement classRecategorized == anotherClass.! !

SlotClassBuilderTest subclass: #SlotClassBuilderSilentTest
	instanceVariableNames: 'yetAnotherClass yetYetAnotherClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SlotTests'!

!SlotClassBuilderSilentTest methodsFor: 'helpers' stamp: 'MartinDias 7/8/2013 16:05'!
assertClassBuiltWith: blockToBuildAClass isEqualToClassBuiltWith: blockToBuildAnotherClass
	
	aClass := self make: [ :builder | 
		builder 
			name: self aClassName;
			in: blockToBuildAClass ].
		
	anotherClass := self make: [ :builder | 
		builder 
			name: self anotherClassName;
			in: blockToBuildAnotherClass ].
	
	self assert: aClass layout equals: aClass layout.	
	self assert: aClass layout equals: anotherClass layout.
	self assert: aClass layout hash equals: anotherClass layout hash.! !

!SlotClassBuilderSilentTest methodsFor: 'helpers' stamp: 'MartinDias 7/8/2013 16:05'!
assertClassBuiltWith: blockToBuildAClass isNotEqualToClassBuiltWith: blockToBuildAnotherClass
		
	aClass := self make: [ :builder | 
		builder 
			name: self aClassName;
			in: blockToBuildAClass ].
		
	anotherClass := self make: [ :builder | 
		builder 
			name: self anotherClassName;
			in: blockToBuildAnotherClass ].
	
	self assert: aClass layout ~= anotherClass layout.
	self assert: aClass layout hash ~= anotherClass layout hash.! !

!SlotClassBuilderSilentTest methodsFor: 'helpers' stamp: 'MartinDias 7/8/2013 16:05'!
assertInvalidClassName: aName

	self should: [
		self make: [ :builder | 
			builder name: aName ] ]
		raise: InvalidGlobalNameConflict.
	self flag: 'should remove class if not raised'.
		
	self should: [
		PharoClassInstaller 
			validateClassName: aName ]
		raise: InvalidGlobalNameConflict! !

!SlotClassBuilderSilentTest methodsFor: 'helpers' stamp: 'MartinDias 6/3/2013 17:06'!
runCase

	SystemAnnouncer uniqueInstance suspendAllWhile: [ super runCase ]
! !

!SlotClassBuilderSilentTest methodsFor: 'helpers' stamp: 'MartinDias 7/8/2013 16:05'!
should: superclassBlock extendWith: subclassBlock

	| superclass |
	superclass := self make: superclassBlock.

	self make: [ :builder | 
		builder 
			superclass: superclass;
			name: self anotherClassName;
			in: subclassBlock ]! !

!SlotClassBuilderSilentTest methodsFor: 'helpers' stamp: 'MartinDias 7/8/2013 16:05'!
shouldnt: superclassBlock extendWith: subclassBlock

	| superclass |
	superclass := self make: superclassBlock.

	self should: [
		self make: [ :builder | 
			builder 
				superclass: superclass;
				name: self anotherClassName;
				in: subclassBlock ] ]
		raise: PrimitiveTypeConflict! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testAddAndAddInstVarNamedWithTrait2
	"Add instance variables using the builder interface"
	
	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			traitComposition: TOne;
			slots: #( x )
		].

	self assertTraitIntegrity.
	self assert: aClass instVarNames equals: #(x).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.

	aClass addInstVarNamed: #y.
	self assertTraitIntegrity.
	aClass addInstVarNamed: #z.
	
	self assert: aClass instVarNames equals: #(x y z).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testAddAndRemoveInstVarNamedWithTrait2
	"Add instance variables using the builder interface"
	
	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			traitComposition: TOne;
			slots: #( x )
		].
	
	self assertTraitIntegrity.
	self assert: aClass instVarNames equals: #(x).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.

	aClass addInstVarNamed: #y.
	self assertTraitIntegrity.
	aClass	removeInstVarNamed: #x.
	
	self assert: aClass instVarNames equals: #(y).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-class slots' stamp: 'MartinDias 7/8/2013 16:05'!
testAddClassSlotAndMigrate

	| classAdded classModified |
	classAdded := 
		self make: [ :builder | 
			builder classSlots: #(a) ].

	classAdded instVarNamed: #a put: $A.
	
	classModified := 
		self make: [ :builder | 
			builder classSlots: #(a b) ].
	
	self assert: (classModified instVarNamed: #a) equals: $A.
	self assert: (classModified instVarNamed: #b) isNil.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testAddInstVarNamed
	"Add instance variables using the builder interface"
	
	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			slots: #( x )
		].

	self assert: aClass instVarNames = #(x).	


	anotherClass := self make: [ :builder |
		builder 
			superclass: aClass;
			name: self anotherClassName;
			slots: #( y )
		].
	
	self assert: anotherClass instVarNames = #(y).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testAddInstVarNamedClassInterface

	"Add instance variables using the class interface"
	
	aClass := self make: [ :builder |
		builder name: self aClassName 
		].
	aClass addInstVarNamed: 'x'.

	self assert: aClass instVarNames = #(x).	


	anotherClass := self make: [ :builder |
		builder 
			superclass: aClass;
			name: self anotherClassName.
		].
	anotherClass addInstVarNamed: 'y'.
	
	self assert: anotherClass instVarNames = #(y).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testAddInstVarNamedWithTrait
	"Add instance variables using the builder interface"
	
	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			traitComposition: TOne;
			slots: #( x )
		].
	self assertTraitIntegrity.
	self assert: aClass instVarNames equals: #(x).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.

	aClass :=  self make: [ :builder |
		builder 
			name: self aClassName;
			traitComposition: TOne;
			slots: #( x y )].
		
	self assertTraitIntegrity.
	self assert: aClass instVarNames = #(x y).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testAddInstVarNamedWithTrait2
	"Add instance variables using the builder interface"
	
	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			traitComposition: TOne;
			slots: #( x )
		].

	self assertTraitIntegrity.
	self assert: aClass instVarNames equals: #(x).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.

	aClass addInstVarNamed: #y.
	
	self assertTraitIntegrity.
	self assert: aClass instVarNames = #(x y).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-shared pools' stamp: 'MartinDias 7/8/2013 16:05'!
testAddSharedPool

	self make: [ :builder | 
		builder sharedPools: '' ].

	aClass := self make: [ :builder | 
		builder sharedPools: 'TestSharedPool' ].
	
	self assert: (aClass sharedPools includes: TestSharedPool).
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-shared variables' stamp: 'MartinDias 7/8/2013 16:05'!
testAddSharedVariable

	self make: [ :builder | 
		builder sharedVariables: '' ].

	aClass := self make: [ :builder | 
		builder sharedVariables: 'Var' ].
	
	self assert: aClass classVarNames equals: #(Var).
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/8/2013 16:06'!
testAddSlotAndMigrate
	"We create a class without slots and create an instance; then we add a slot and check the instance can hold a value."
	aClass := self makeWithLayout: PointerLayout.
	
	instance := aClass new.
	
	"now we extend it with slots.  The class definition should've changed"
	self makeWithLayout: PointerLayout andSlots: { #aSlot }.
	
	"it should have an instance variable"
	instance instVarAt: 1 put: 125.
	aClass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/8/2013 16:07'!
testAddSlotPropagateAndMigrate
	"We create a class without slots and a subclass, and create an instance of the latter; then we add a slot to superclass and check the instance can hold a value."

	| superclass subclass |
	superclass := self makeWithLayout: PointerLayout.
	subclass := self make: [ :builder |
		builder 
			superclass: superclass;
			name: self anotherClassName.
		 ].
	
	superclass layout checkIntegrity.
	subclass layout checkIntegrity.
	
	instance := subclass new.
	
	"now we extend it with slots.  The class definition should've changed"
	superclass := self makeWithLayout: PointerLayout andSlots: { #aSlot }.
	
	"it should have an instance variable"
	instance instVarNamed: 'aSlot' put: 42.
	self assert: (instance instVarNamed: 'aSlot') equals: 42.
	superclass layout checkIntegrity.
	subclass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testAnonymousSubclass
	
	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			slots: #(x)
		].

	anotherClass := aClass classBuilder anonymousSubclassOf: aClass.

	self deny: anotherClass == aClass.
	self assert: anotherClass isBehavior.
	self assert: anotherClass superclass == aClass.
	self deny: anotherClass name = aClass name.
	self assert: anotherClass allInstVarNames = #(x)! !

!SlotClassBuilderSilentTest methodsFor: 'tests-basic' stamp: 'MartinDias 7/8/2013 16:05'!
testBasicClassBuilding

	aClass := self make: [ :builder |
		builder name: self aClassName ].
	
	self deny: aClass layout isNil.
	self assert: aClass name = self aClassName.
	self assert: (self class environment at: self aClassName) == aClass.
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-environment' stamp: 'MartinDias 7/8/2013 16:05'!
testBasicEnvironment
	| environment |
	environment := SystemDictionary new.
	environment at: #SystemOrganization put: SystemOrganizer new.

	aClass := self make: [ :builder | 
		builder environment: environment ].

	self assert: (aClass environment == environment).
	self assert: (environment includesKey: aClass name).	
	self assert: (environment at: aClass name) == aClass.
	
	self deny: (Smalltalk globals includesKey: aClass name).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testByteCanExtendByte

	self should: [ :builder | 
			builder layoutClass: ByteLayout ]
		extendWith: [ :builder | 
			builder layoutClass: ByteLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testByteCannotExtendPointerWithFields

	self shouldnt: [ :builder | 
			builder 
				layoutClass: PointerLayout;
				slots: { #a }. ]
		extendWith: [ :builder | 
			builder layoutClass: ByteLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testByteCannotExtendWord

	self shouldnt: [ :builder | 
			builder layoutClass: WordLayout ]
		extendWith: [ :builder | 
			builder layoutClass: ByteLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/8/2013 16:05'!
testCannotBeRecompiled

	| superclass |
	superclass := self make: [ :builder | 
		builder 
			superclass: Object;
			name: self aClassName ].

	self make: [ :builder | 
		builder 
			superclass: superclass;
			name: self anotherClassName ].

	self 
		should: [ 
			self make: [ :builder | 
				builder 
					layoutClass: VariableLayout;
					name: self aClassName ] ]
		raise: Error
		description: 'Old class builder raises: X cannot be recompiled'
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/8/2013 16:05'!
testChangingFormatKeepsMethod

	aClass := self make: [ :builder | 
		builder 
			name: self aClassName;
			layoutClass: PointerLayout ].

	aClass compile: 'a ^self'.
	self assert: (aClass methodDictionary includesKey: #a).
	
	anotherClass := self make: [ :builder | 
		builder 
			name: self aClassName;
			layoutClass: VariableLayout .
			].

	self assert: (anotherClass methodDictionary includesKey: #a).
	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 6/3/2013 16:59'!
testCheckAllLayouts
	self shouldnt: [SlotVirus checkAllLayouts] raise: Error! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 6/3/2013 16:58'!
testClassNameMustBeCapitalized

	self assertInvalidClassName: #aNotCapitalizedClassName! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/1/2013 16:08'!
testClassNameMustBeSymbol

	self assertInvalidClassName: 1! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 6/3/2013 16:58'!
testClassNameWithInvalidCharacter

	self assertInvalidClassName: #'Invalid-ClassName'! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/8/2013 16:05'!
testClassSlotDuplicationConflict

	aClass := self make: [ :builder | 
		builder classSlots: { #a } ].

	self should: [ 
		self make: [ :builder | 
			builder 
				superclass: aClass;
				name: self anotherClassName;
				classSlots: { #a } ] ]
		raise: SlotDuplicationConflict ! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/8/2013 16:05'!
testClassSlotWithReservedName

	#(#self #super #thisContext #true #false #nil) do: [:reservedName |
		self should: [ 
			self make: [ :builder | 
				builder classSlots: { reservedName } ] ]
			raise: InvalidSlotNameConflict ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testClassWithClassTrait

	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
	
	aClass := self make: [ :builder | 
		builder classTraitComposition: TOne ].
	
	self assert: TOne users asArray equals: { aClass class }.
	self assert: TOne classTrait users isEmpty.
	
	self assert: (aClass class canUnderstand: #one).
	self assert: aClass one equals: 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testClassWithTrait

	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
	
	aClass := self make: [ :builder | 
		builder traitComposition: TOne ].
	
	self assert: TOne users asArray equals: { aClass }.
	self assert: TOne classTrait users isEmpty.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testClassWithTrait2

	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
	
	aClass := self make: [ :builder | 
		builder traitComposition: TOne classTrait ].
	
	self assert: TOne users isEmpty.
	self assert: TOne classTrait users asArray equals: { aClass }.
	
	self deny: (aClass canUnderstand: #one).
	self assert: (aClass canUnderstand: #classOne).
	self assert: aClass new classOne equals: 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 7/3/2013 16:42'!
testCompiledMethodCanBeExtended

	self should: [ :builder | 
			builder layoutClass: CompiledMethodLayout ]
		extendWith: [ :builder | 
			builder layoutClass: CompiledMethodLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 6/3/2013 16:59'!
testCompiledMethodLayout
	self assert: (CompiledMethod layout isKindOf: CompiledMethodLayout).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/8/2013 16:05'!
testDirectCircularHierarchyError
	"Tests an error is raised when trying to create a heirarchy A<-A"
	
	| classA classB |
	classA := self make: [ :builder |
			builder 
				superclass: Object;
				name: self aClassName ].

	self should: [ 
		self make: [ :builder | 
			builder 
				superclass: classA;
				name: self aClassName ] ]
		raise: CircularHierarchyConflict ! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/8/2013 16:05'!
testIndirectCircularHierarchyError
	"Tests an error is raised when trying to create a heirarchy A<-B<-A"
	
	| classA classB |
	classA := self make: [ :builder |
			builder 
				superclass: Object;
				name: self aClassName ].

	classB := self make: [ :builder |
			builder 
				superclass: classA;
				name: self anotherClassName ].

	self should: [ 
		self make: [ :builder | 
			builder 
				superclass: classB;
				name: self aClassName ] ]
		raise: CircularHierarchyConflict ! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 7/11/2013 14:12'!
testInstanceVariableNamesMetaclassInterface
	"Add instance variables using the Metaclass interface"
	
	aClass := self make: [ :builder |
		builder name: self aClassName ].
	aClass class instanceVariableNames: 'x'.

	self assert: aClass class instVarNames equals: #(x).	

	anotherClass := self make: [ :builder |
		builder 
			superclass: aClass;
			name: self anotherClassName ].
	anotherClass class instanceVariableNames: 'y'.
	
	self assert: anotherClass class instVarNames equals: #(y).	
	self assert: (anotherClass class allInstVarNames includesAll: #(x y)).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-layout equality' stamp: 'MartinDias 6/3/2013 16:59'!
testLayoutEquals

	self layoutClasses do: [:aLayoutClass |
		self 
			assertClassBuiltWith: [:builder | builder layoutClass: aLayoutClass ] 
			isEqualToClassBuiltWith: [:builder | builder layoutClass: aLayoutClass ] ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-layout equality' stamp: 'MartinDias 6/3/2013 16:59'!
testLayoutNotEquals
 
	self layoutClasses do: [:aLayoutClass |
		(self layoutClasses copyWithout: aLayoutClass) do: [:anotherLayoutClass |
			self 
				assertClassBuiltWith: [:builder | builder layoutClass: aLayoutClass ] 
				isNotEqualToClassBuiltWith: [:builder | builder layoutClass: anotherLayoutClass ]]]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-layout equality' stamp: 'MartinDias 6/3/2013 16:59'!
testLayoutWithSlotsEquals

	self layoutClassesWithSlots do: [:aLayoutClass |
		self 
			assertClassBuiltWith: [:builder | 
				builder 
					layoutClass: aLayoutClass;
					slots: { #field1}  ]
			isEqualToClassBuiltWith: [:builder | 
				builder 
					layoutClass: aLayoutClass;
					slots: { #field1}  ].]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-layout equality' stamp: 'MartinDias 6/3/2013 16:59'!
testLayoutWithSlotsNotEquals

	self layoutClassesWithSlots do: [:aLayoutClass |
		self 
			assertClassBuiltWith: [:builder | 
				builder 
					layoutClass: aLayoutClass;
					slots: { #field1}  ]
			isNotEqualToClassBuiltWith: [:builder | 
				builder 
					layoutClass: aLayoutClass;
					slots: { #field2}  ]]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testModifyClassTraitComposition
	"Tests that when modifing the trait composition on class-side, the old methods are removed from the method dictionary, and the new ones are added."

	self make: [ :builder | 
		builder classTraitComposition: TOne ].

	aClass := self make: [ :builder | 
		builder classTraitComposition: TTwo ].
	
	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
	self assert: TTwo users asArray equals: { aClass class }.
	self assert: TTwo classTrait users isEmpty.
	
	self deny: (aClass class canUnderstand: #one).
	self deny: (aClass class canUnderstand: #classOne).
	self assert: (aClass class canUnderstand: #two).
	aClass layout checkIntegrity.


	aClass := self make: [ :builder | 
		builder classTraitComposition: { } ].
	
	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
	self assert: TTwo users isEmpty.
	self assert: TTwo classTrait users isEmpty.
	aClass layout checkIntegrity.
	
	self deny: (aClass canUnderstand: #one).
	self deny: (aClass class canUnderstand: #classOne).
	self deny: (aClass canUnderstand: #two).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testModifyTraitComposition
	"Tests that when modifing the trait composition, the old methods are removed from the method dictionary, and the new ones are added."
	
	self make: [ :builder | 
		builder traitComposition: TOne ].

	aClass := self make: [ :builder | 
		builder traitComposition: TTwo ].
	
	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
	self assert: TTwo users asArray equals: { aClass }.
	"self assert: TTwo classTrait users isEmpty."
	aClass layout checkIntegrity.
	
	self deny: (aClass canUnderstand: #one).
	self deny: (aClass class canUnderstand: #classOne).
	self assert: (aClass canUnderstand: #two).
	
	
	aClass := self make: [ :builder | 
		builder traitComposition: { } ].
	
	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
	self assert: TTwo users isEmpty.
	self assert: TTwo classTrait users isEmpty.
	aClass layout checkIntegrity.
	
	self deny: (aClass canUnderstand: #one).
	self deny: (aClass class canUnderstand: #classOne).
	self deny: (aClass canUnderstand: #two).
	
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-basic' stamp: 'MartinDias 7/8/2013 16:05'!
testNewCompiledMethodClass

	aClass := self makeWithLayout: CompiledMethodLayout.

	self deny: aClass isCompact.
	self deny: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isBytes.
	self deny: aClass isWeak.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-basic' stamp: 'MartinDias 7/8/2013 16:05'!
testNewPointerClass

	aClass := self makeWithLayout: PointerLayout.
	
	self deny: aClass isCompact.
	self assert: aClass isPointers.
	self assert: aClass isFixed.
	self assert: aClass instVarNames isEmpty.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-basic' stamp: 'MartinDias 7/8/2013 16:06'!
testNewPointerClassWithSlots

	aClass := self 
		makeWithLayout: PointerLayout
		andSlots: { #id. #name }.
	
	self assert: (aClass instVarNames includes: 'id').
	self assert: (aClass instVarNames includes: 'name').! !

!SlotClassBuilderSilentTest methodsFor: 'tests-basic' stamp: 'MartinDias 7/8/2013 16:05'!
testNewVariableByteClass

	aClass := self makeWithLayout: ByteLayout.
	
	self deny: aClass isCompact.
	self deny: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isBytes.
	self assert: aClass isVariable.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-basic' stamp: 'MartinDias 7/8/2013 16:05'!
testNewVariableWordClass

	aClass := self makeWithLayout: WordLayout.
	
	self deny: aClass isCompact.
	self deny: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isWords.
	self assert: aClass isVariable.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-basic' stamp: 'MartinDias 7/8/2013 16:05'!
testNewWeakClass

	aClass := self makeWithLayout: WeakLayout.
	
	self deny: aClass isCompact.
	self assert: aClass isPointers.
	self deny: aClass isFixed.
	self assert: aClass isWords.
	self assert: aClass isWeak.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-example' stamp: 'MartinDias 7/1/2013 16:13'!
testPharoClassInstallerExample
	| newClass |
	[ 
		newClass := PharoClassInstaller example.
		self assert: newClass isBehavior.
	] ensure: [ 
		newClass removeFromSystem ].! !

!SlotClassBuilderSilentTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testPointerCanExtendPointer

	self should: [ :builder | 
			builder layoutClass: PointerLayout ]
		extendWith: [ :builder | 
			builder layoutClass: PointerLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testPointerCanExtendVariable

	self should: [ :builder | 
			builder layoutClass: VariableLayout ]
		extendWith: [ :builder | 
			builder layoutClass: PointerLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testPointerCannotExtendByte

	self shouldnt: [ :builder | 
			builder layoutClass: ByteLayout ]
		extendWith: [ :builder | 
			builder layoutClass: PointerLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testPointerCannotExtendWord

	self shouldnt: [ :builder | 
			builder layoutClass: WordLayout ]
		extendWith: [ :builder | 
			builder layoutClass: PointerLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 7/8/2013 16:05'!
testPointerWithVariableExtensionIsNowVariable
	"This test case reproduces a real bug."

	| superclass subclass |
	superclass := self make: [ :builder | 
		builder 
			superclass: Object;
			name: self aClassName ].

	subclass := self make: [ :builder | 
		builder 
			superclass: superclass;
			layoutClass: VariableLayout;
			name: self anotherClassName ].

	superclass := self make: [ :builder | 
		builder layoutClass: VariableLayout ].

	self assert: superclass isVariable.
	self assert: subclass isVariable.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/8/2013 16:05'!
testRedefineSuperclass
	"This case reproduces a MNU found loading Moose."

	| superclass class |
	superclass := self makeWithLayout: PointerLayout.
	class := self make: [ :builder |
		builder 
			superclass: superclass;
			layoutClass: ByteLayout;
			name: self anotherClassName.
		 ].

	self makeWithLayout: PointerLayout.

	superclass layout checkIntegrity.
	class layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-class slots' stamp: 'MartinDias 7/8/2013 16:05'!
testRemoveClassSlotAndMigrate

	| classAdded classModified |
	classAdded := 
		self make: [ :builder | 
			builder classSlots: #(a b) ].

	classAdded instVarNamed: #a put: $A.
	
	classModified := 
		self make: [ :builder | 
			builder classSlots: #(a) ].
	
	self assert: (classModified instVarNamed: #a) equals: $A.
	self should: [ classModified instVarNamed: #b ] raise: Error
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testRemoveClassTrait
	"Tests that when removing a trait from class-side, its methods are removed from the method dictionary."

	aClass := self make: [ :builder | 
		builder classTraitComposition: TOne ].

	aClass := self make: [ :builder | 
		builder classTraitComposition: {} ].
	
	self deny: (aClass class canUnderstand: #one).
	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testRemoveInstVarNamed

	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			slots: #(x y z) 
		].
	aClass  := self make: [ :builder |
		builder 
			name: self aClassName;
			slots: #(x   z) 
		].

	self assert: aClass instVarNames = #(x z).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testRemoveInstVarNamedClassInterface

	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			slots: #(x y z) 
		].
	aClass removeInstVarNamed: #y.

	self assert: aClass instVarNames = #(x z).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/8/2013 16:05'!
testRemoveInstVarNamedWithTrait2
	"Add instance variables using the builder interface"
	
	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			traitComposition: TOne;
			slots: #( x )
		].

	self assert: aClass instVarNames equals: #(x).
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.

	aClass removeInstVarNamed: #x.
	
	self assert: aClass instVarNames isEmpty.
	
	self assert: TOne users asArray equals: { aClass }.
	
	self assert: (aClass canUnderstand: #one).
	self assert: aClass new one equals: 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-shared pools' stamp: 'MartinDias 7/8/2013 16:05'!
testRemoveSharedPool

	self make: [ :builder | 
		builder sharedPools: 'TestSharedPool' ].

	aClass := self make: [ :builder | 
		builder sharedPools: '' ].
	
	self assert: aClass sharedPools isEmpty
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-shared variables' stamp: 'MartinDias 7/8/2013 16:05'!
testRemoveSharedVariable

	self make: [ :builder | 
		builder sharedVariables: 'Var' ].

	aClass := self make: [ :builder | 
		builder sharedVariables: '' ].
	
	self assert: aClass classVarNames isEmpty! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/8/2013 16:06'!
testRemoveSlotAndMigrate
	"We create a class with a slot and create an instance; then we remove the slot and check the instance doesn't hold the value."
	aClass := self makeWithLayout: PointerLayout andSlots: { #aSlot }.

	instance := aClass new.
	"it should have an instance variable"
	instance instVarAt: 1 put: 125.
	
	"now we extend it with slots.  The class definition should've changed"
	self makeWithLayout: PointerLayout.
	
	self should: [ instance instVarAt: 1 ] raise: Error.
	aClass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testRemoveTrait
	"Tests that when removing a trait from a class, its methods are removed from the method dictionary."
	
	self make: [ :builder | 
		builder traitComposition: TOne ].
	
	aClass := self make: [ :builder | 
		builder traitComposition: {} ].
	
	self assert: TOne users isEmpty.
	self assert: TOne classTrait users isEmpty.
	self deny: (aClass canUnderstand: #one).
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/11/2013 15:33'!
testReshapeClassPropagatesToDeepHierarchy
	"Test reshaping a class which is head of a hierarchy of 4 levels"
	
	"level 1"
	aClass := self make: [ :builder |
		builder name: self aClassName ].

	self assert: aClass subclasses isEmpty.
	aClass layout checkIntegrity.

	"level 2"
	anotherClass := self make: [ :builder |
		builder 
			superclass: aClass;
			name: self anotherClassName ].
	
	self assert: aClass subclasses equals: { anotherClass }.
	self assert: anotherClass subclasses isEmpty.
	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.

	"level 3"
	yetAnotherClass := self make: [ :builder |
		builder 
			superclass: anotherClass;
			name: self yetAnotherClassName ].

	self assert: aClass subclasses equals: { anotherClass }.
	self assert: anotherClass subclasses equals: { yetAnotherClass }.
	self assert: yetAnotherClass subclasses isEmpty.
	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.
	yetAnotherClass layout checkIntegrity.

	"level 4"
	yetYetAnotherClass := self make: [ :builder |
		builder 
			superclass: yetAnotherClass;
			name: self yetYetAnotherClassName ].


	self assert: aClass subclasses equals: { anotherClass }.
	self assert: anotherClass subclasses equals: { yetAnotherClass }.
	self assert: yetAnotherClass subclasses equals: { yetYetAnotherClass }.
	self assert: yetYetAnotherClass subclasses isEmpty.
	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.
	yetAnotherClass layout checkIntegrity.
	yetYetAnotherClass layout checkIntegrity.

	"reshape level 1"
	aClass := self make: [ :builder |
		builder 
			name: self aClassName;
			slots:#(x) ].

	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.
	yetAnotherClass layout checkIntegrity.
	yetYetAnotherClass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 7/11/2013 15:33'!
testReshapeClassPropagatesToDeepHierarchyClassInterface
	"Test reshaping a class which is head of a hierarchy of 4 levels"
	
	"level 1"
	aClass := Object
		subclass: self aClassName 
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self aCategory.

	self assert: aClass subclasses isEmpty.
	aClass layout checkIntegrity.

	"level 2"
	anotherClass := aClass
		subclass: self anotherClassName 
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self aCategory.
	
	self assert: aClass subclasses equals: { anotherClass }.
	self assert: anotherClass subclasses isEmpty.
	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.

	"level 3"
	yetAnotherClass := anotherClass
		subclass: self yetAnotherClassName 
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self aCategory.

	self assert: aClass subclasses equals: { anotherClass }.
	self assert: anotherClass subclasses equals: { yetAnotherClass }.
	self assert: yetAnotherClass subclasses isEmpty.
	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.
	yetAnotherClass layout checkIntegrity.

	"level 4"
	yetYetAnotherClass := yetAnotherClass
		subclass: self yetYetAnotherClassName 
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self aCategory.

	self assert: aClass subclasses equals: { anotherClass }.
	self assert: anotherClass subclasses equals: { yetAnotherClass }.
	self assert: yetAnotherClass subclasses equals: { yetYetAnotherClass }.
	self assert: yetYetAnotherClass subclasses isEmpty.
	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.
	yetAnotherClass layout checkIntegrity.
	yetYetAnotherClass layout checkIntegrity.

	"reshape level 1"
	aClass := Object
		subclass: self aClassName 
		instanceVariableNames: 'x' 
		classVariableNames: '' 
		poolDictionaries: '' 
		category: self aCategory.

	self assert: aClass instVarNames equals: #(x).
	aClass layout checkIntegrity.
	anotherClass layout checkIntegrity.
	yetAnotherClass layout checkIntegrity.
	yetYetAnotherClass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/8/2013 16:59'!
testReshapeSuperSuperClass

	| supersuperclass superclass subclass |

	supersuperclass := self make: [ :builder |
		builder 
			superclass: Object;
			name: self aClassName;
			slots: #(a b).
		 ].

	self assert: supersuperclass subclasses isEmpty.
	supersuperclass layout checkIntegrity.
	
	superclass := self make: [ :builder |
		builder 
			superclass: supersuperclass;
			name: self anotherClassName.
		 ].

	self assert: supersuperclass subclasses equals: { superclass }.
	self assert: superclass subclasses isEmpty.
	superclass layout checkIntegrity.
	supersuperclass layout checkIntegrity.
	
	subclass := self make: [ :builder |
		builder 
			superclass: superclass;
			name: self yetAnotherClassName;
			slots:#(c d).
		 ].

	self assert: supersuperclass subclasses equals: { superclass }.
	self assert: superclass subclasses equals: { subclass }.
	self assert: subclass subclasses isEmpty.
	subclass layout checkIntegrity.
	superclass layout checkIntegrity.
	supersuperclass layout checkIntegrity.

	"reshape the super super class"
	supersuperclass := self make: [ :builder |
		builder 
			superclass: Object;
			name: self aClassName;
			slots: #(a b a2).
		 ].
	
	self assert: supersuperclass subclasses equals: { superclass }.
	self assert: superclass subclasses equals: { subclass }.
	self assert: subclass subclasses isEmpty.	
	subclass layout checkIntegrity.
	superclass layout checkIntegrity.
	supersuperclass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/8/2013 16:06'!
testShiftSlotAndMigrate

	aClass := self makeWithLayout: PointerLayout andSlots: { #a. #c }.
	aClass compile: 'a ^a'.
	aClass compile: 'c ^c'.
	
	instance := aClass new.
	instance instVarNamed: #a put: 1.
	instance instVarNamed: #c put: 3.

	"now we extend it with slots.  The class definition should've changed"
	self makeWithLayout: PointerLayout andSlots: { #a. #b. #c }.

	"it should have added an instance variable with nil in the middle"
	self assert: (instance instVarAt: 1) equals: 1.
	self assert: (instance instVarAt: 2) equals: nil.
	self assert: (instance instVarAt: 3) equals: 3.
	
	self assert: (instance instVarNamed: #a) equals: 1.
	self assert: (instance instVarNamed: #b) equals: nil.
	self assert: (instance instVarNamed: #c) equals: 3.
	
	"it should have migrated methods"
	self assert: instance a equals: 1.
	self assert: instance c equals: 3.
	aClass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/8/2013 16:05'!
testSlotDuplicationConflict

	aClass := self make: [ :builder | 
		builder slots: { #a } ].

	self should: [ 
		self make: [ :builder | 
			builder 
				superclass: aClass;
				name: self anotherClassName;
				slots: { #a } ] ]
		raise: SlotDuplicationConflict ! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 7/8/2013 16:05'!
testSlotWithReservedName

	#(#self #super #thisContext #true #false #nil) do: [:reservedName |
		self should: [ 
			self make: [ :builder | 
				builder slots: { reservedName } ] ]
			raise: InvalidSlotNameConflict ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-integration' stamp: 'MartinDias 6/3/2013 16:59'!
testSmallIntegerLayout
	self assert: (SmallInteger layout isKindOf: SmallIntegerLayout).! !

!SlotClassBuilderSilentTest methodsFor: 'tests-class slots' stamp: 'MartinDias 7/8/2013 16:05'!
testSwitchClassSlotAndMigrate

	| classAdded classModified |	
	classAdded := 
		self make: [ :builder | 
			builder classSlots: #(a b) ].

	"Add methods"	
	classAdded class 
		compile: 'a ^a';
		compile: 'b ^b'.

	"Put values"
	classAdded instVarNamed: #a put: $A.
	classAdded instVarNamed: #b put: $B.

	"Modify the class"	
	classModified := 
		self make: [ :builder | 
			builder classSlots: #(b a) ].
	
	"The instance was migrated"
	self assert: (classModified instVarNamed: #a) equals: $A.
	self assert: (classModified instVarNamed: #b) equals: $B.
	
	"The methods were migrated"
	self assert: classModified a equals: $A.
	self assert: classModified b equals: $B.
! !

!SlotClassBuilderSilentTest methodsFor: 'tests-migrations' stamp: 'MartinDias 7/8/2013 16:06'!
testSwitchSlotsAndMigrate

	aClass := self makeWithLayout: PointerLayout andSlots: { #a. #b }.
	aClass 
		compile: 'a ^a';
		compile: 'b ^b'.

	instance := aClass new.
	instance instVarNamed: #a put: $A.
	instance instVarNamed: #b put: $B.

	"now we switch the slots. The class definition should've changed"
	self makeWithLayout: PointerLayout andSlots: { #b. #a }.

	self assert: (instance instVarAt: 1) equals: $B.
	self assert: (instance instVarAt: 2) equals: $A.
	
	self assert: (instance instVarNamed: #a) equals: $A.
	self assert: (instance instVarNamed: #b) equals: $B.

	"it should have migrated methods"
	self assert: instance a equals: $A.
	self assert: instance b equals: $B.
	aClass layout checkIntegrity.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testTraitUsersAfterClassReshape

	aClass := self make: [ :builder | 
		builder
			name: self aClassName ].

	anotherClass := self make: [ :builder | 
		builder
			name: self anotherClassName;
			superclass: aClass;
			traitComposition: TOne;
			classTraitComposition: TOne classTrait + TTwo ].
	
	self assert: TOne users asArray equals: { anotherClass }.
	self assert: TOne classTrait users asArray equals: { anotherClass class }.
	self assert: TTwo users asArray equals: { anotherClass class }.
	self assert: TTwo classTrait users asArray equals: { }.
	
	self deny: (aClass canUnderstand: #one).
	self assert: (anotherClass canUnderstand: #one).
	self deny: (aClass class canUnderstand: #two).
	self assert: (anotherClass class canUnderstand: #two).
	
	
	"reshape the super class"
	aClass := self make: [ :builder | 
		builder
			name: self aClassName;
			slots: #( x y z ) ].
		
	self assert: TOne users asArray equals: { anotherClass }.
	self assert: TOne classTrait users asArray equals: { anotherClass class }.
	self assert: TTwo users asArray equals: { anotherClass class }.
	self assert: TTwo classTrait users asArray equals: { }.
	
	self deny: (aClass canUnderstand: #one).
	self assert: (anotherClass canUnderstand: #one).
	self deny: (aClass class canUnderstand: #two).
	self assert: (anotherClass class canUnderstand: #two).

! !

!SlotClassBuilderSilentTest methodsFor: 'tests-traits' stamp: 'MartinDias 7/8/2013 16:05'!
testTraitUsersAfterMetaclassReshape

	aClass := self make: [ :builder | 
		builder
			name: self aClassName ].

	anotherClass := self make: [ :builder | 
		builder
			name: self anotherClassName;
			superclass: aClass;
			traitComposition: TOne;
			classTraitComposition: TOne classTrait + TTwo ].
	
	
	self assert: TOne users asArray            equals: { anotherClass }.
	self assert: TOne classTrait users asArray equals: { anotherClass class }.
	self assert: TTwo users asArray            equals: { anotherClass class }.
	self assert: TTwo classTrait users asArray equals: { }.
	
	self deny: (aClass canUnderstand: #one).
	self assert: (anotherClass canUnderstand: #one).
	self deny: (aClass class canUnderstand: #two).
	self assert: (anotherClass class canUnderstand: #two).
	
	"reshape the super class"
	aClass := self make: [ :builder | 
		builder
			name: self aClassName;
			classSlots: #( x y z ) ].
		
	
	self assert: TOne users asArray            equals: { anotherClass }.
	self assert: TOne classTrait users asArray equals: { anotherClass class }.
	self assert: TTwo users asArray            equals: { anotherClass class }.
	self assert: TTwo classTrait users asArray equals: { }.
	
	self deny: (aClass canUnderstand: #one).
	self assert: (anotherClass canUnderstand: #one).
	self deny: (aClass class canUnderstand: #two).
	self assert: (anotherClass class canUnderstand: #two).

! !

!SlotClassBuilderSilentTest methodsFor: 'tests-errors' stamp: 'MartinDias 6/3/2013 16:58'!
testValidateClassName		
		
	PharoClassInstaller 
		validateClassName: #GoodClassNameThatShouldNotExist! !

!SlotClassBuilderSilentTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testVariableCanExtendPointer

	self should: [ :builder | 
			builder layoutClass: PointerLayout ]
		extendWith: [ :builder | 
			builder layoutClass: VariableLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testVariableCanExtendVariable

	self should: [ :builder | 
			builder layoutClass: VariableLayout ]
		extendWith: [ :builder | 
			builder layoutClass: VariableLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testVariableCannotExtendByte

	self shouldnt: [ :builder | 
			builder layoutClass: ByteLayout ]
		extendWith: [ :builder | 
			builder layoutClass: VariableLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testVariableCannotExtendWord

	self shouldnt: [ :builder | 
			builder layoutClass: WordLayout ]
		extendWith: [ :builder | 
			builder layoutClass: VariableLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-class slots' stamp: 'MartinDias 7/8/2013 16:05'!
testWithClassSlots

	aClass := self make: [ :builder | 
		builder classSlots: #(a) ].
	
	self assert: aClass class instVarNames equals: #(a).	
	aClass instVarNamed: #a put: $A.
	self assert: (aClass instVarNamed: #a) equals: $A.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-shared pools' stamp: 'MartinDias 7/8/2013 16:05'!
testWithSharedPool

	aClass := self make: [ :builder | 
		builder sharedPools: 'TestSharedPool' ].
	aClass class compile: 'one ^One'.
	
	self assert: (aClass sharedPools includes: TestSharedPool).
	self assert: aClass one = 1.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-shared variables' stamp: 'MartinDias 7/8/2013 16:05'!
testWithSharedVariable

	aClass := self make: [ :builder | 
		builder sharedVariables: 'Var' ].
	aClass class 
		compile: 'var:x  Var:=x';
		compile: 'var  ^Var'.
	
	aClass var: true.
	
	self assert: aClass classVarNames equals: #(Var).
	self assert: aClass var.! !

!SlotClassBuilderSilentTest methodsFor: 'tests-class slots' stamp: 'MartinDias 7/8/2013 16:05'!
testWithoutClassSlots

	aClass := self make: [ :builder | 
		builder classSlots: #() ].
	
	self assert: aClass classVarNames isEmpty! !

!SlotClassBuilderSilentTest methodsFor: 'tests-shared pools' stamp: 'MartinDias 7/8/2013 16:05'!
testWithoutSharedPools

	aClass := self make: [ :builder | 
		builder sharedPools: '' ].
	
	self assert: aClass sharedPools isEmpty! !

!SlotClassBuilderSilentTest methodsFor: 'tests-shared variables' stamp: 'MartinDias 7/8/2013 16:05'!
testWithoutSharedVariables

	aClass := self make: [ :builder | 
		builder sharedVariables: '' ].
	
	self assert: aClass classVarNames isEmpty! !

!SlotClassBuilderSilentTest methodsFor: 'tests-valid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testWordCanExtendWord

	self should: [ :builder | 
			builder layoutClass: WordLayout ]
		extendWith: [ :builder | 
			builder layoutClass: WordLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testWordCannotExtendByte

	self shouldnt: [ :builder | 
			builder layoutClass: ByteLayout ]
		extendWith: [ :builder | 
			builder layoutClass: WordLayout ]! !

!SlotClassBuilderSilentTest methodsFor: 'tests-invalid extensions' stamp: 'MartinDias 6/3/2013 16:59'!
testWordCannotExtendPointerWithFields

	self shouldnt: [ :builder | 
			builder 
				layoutClass: PointerLayout;
				slots: { #a } ]
		extendWith: [ :builder | 
			builder layoutClass: WordLayout ]! !

!SlotClassBuilderTest methodsFor: 'helpers-names' stamp: 'MartinDias 7/11/2013 15:02'!
aCategory
	^ 'SlotTestsTmp'! !

!SlotClassBuilderTest methodsFor: 'helpers-names' stamp: 'MartinDias 7/11/2013 15:01'!
aClassName
	^ #SlotTestsClassA! !

!SlotClassBuilderTest methodsFor: 'helpers-names' stamp: 'MartinDias 7/11/2013 15:02'!
anotherCategory
	^ 'SlotTestsTmp-Another'! !

!SlotClassBuilderTest methodsFor: 'helpers-names' stamp: 'MartinDias 7/11/2013 15:01'!
anotherClassName
	^ #SlotTestsClassB! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 7/3/2013 17:15'!
assertTraitIntegrity
	self assert: TOne users isHealthy.
	self assert: TOne classTrait users isHealthy.
	self assert: TTwo users isHealthy.
	self assert: TTwo classTrait users isHealthy.! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'CamilloBruni 6/28/2013 23:27'!
cleanUpTrait: trait
	"During development some tests might invalidate the trait internal state.
	To avoid follow-up failures we reset the trait state here as good as possible."
	
	trait users removeAll.
	trait classTrait users removeAll.! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 3/28/2013 12:03'!
expectedFailures 

	^ #( testCannotBeRecompiled )! !

!SlotClassBuilderTest methodsFor: 'helpers-names' stamp: 'MartinDias 4/12/2013 16:08'!
layoutClasses
	^ { ByteLayout. WordLayout. PointerLayout. VariableLayout. WeakLayout }! !

!SlotClassBuilderTest methodsFor: 'helpers-names' stamp: 'MartinDias 4/12/2013 16:09'!
layoutClassesWithSlots
	^ { PointerLayout. VariableLayout. WeakLayout }! !

!SlotClassBuilderTest methodsFor: 'helpers-building' stamp: 'MartinDias 7/8/2013 16:05'!
make: anUnaryBlock
	"I build a class for testing, providing basic default values, but eventually customized by the received unary block."

	^PharoClassInstaller make: [:builder|
		builder
			superclass: Object;
			name: self aClassName;
			layoutClass: PointerLayout;
			category: self aCategory.
		anUnaryBlock value: builder
		].! !

!SlotClassBuilderTest methodsFor: 'helpers-building' stamp: 'MartinDias 7/8/2013 16:06'!
makeWithLayout: aClassLayout
	^self makeWithLayout: aClassLayout andSlots: {}! !

!SlotClassBuilderTest methodsFor: 'helpers-building' stamp: 'MartinDias 7/8/2013 16:06'!
makeWithLayout: aClassLayout andSlots: someSlots
	"
	I create a class using the Slot class builder given a class layout and a collection of slots.
	"

	^self make: [:builder|
		builder
			layoutClass: aClassLayout;
			slots: someSlots
		].! !

!SlotClassBuilderTest methodsFor: 'running' stamp: 'MartinDias 7/11/2013 14:16'!
tearDown
	"We remove the classes that could have been created during test run"
	super tearDown.

	SystemAnnouncer uniqueInstance suspendAllWhile: [
		{ self aClassName. self anotherClassName. self yetAnotherClassName. self yetYetAnotherClassName } do: [ :each | 
			Smalltalk globals 
				at: each 
				ifPresent: [ :class | class removeFromSystem ]]].

	SystemAnnouncer uniqueInstance unsubscribe: self.
	
	self 
		cleanUpTrait: TOne;
		cleanUpTrait: TTwo.! !

!SlotClassBuilderTest methodsFor: 'helpers-names' stamp: 'MartinDias 7/11/2013 15:01'!
yetAnotherClassName
	^ #SlotTestsClassC! !

!SlotClassBuilderTest methodsFor: 'helpers-names' stamp: 'MartinDias 7/11/2013 15:01'!
yetYetAnotherClassName
	^ #SlotTestsClassD! !
TestSharedPool initialize!
